## openmodelica 1.14.2~6-g5c52d52

=== debian/changelog ===
openmodelica (1.14.2~6-g5c52d52-1) unstable; urgency=low

  * Automatic git build
 -- OpenModelica Build System <build@openmodelica.org>  Wed, 11 Nov 2020 13:04:18 -0000
